import QtQuick 1.0

Rectangle {
    property real value: 0
    property bool indeterminate: false

    height: 10
    smooth: true

    Rectangle {
        width:  2
        radius: 1
        height: parent.height
        color: "#CFD0D0"
        anchors.left: parent.left
    }
    Rectangle {
        width:  2
        radius: 1
        height: parent.height
        color: "#CFD0D0"
        anchors.right: parent.right
    }
    Rectangle {
        width:  parent.width
        radius: 1
        height: 2
        color: "#CFD0D0"
        anchors.top: parent.top
    }
    Rectangle {
        width:  parent.width
        radius: 1
        height: 2
        color: "#F0F0F0"
        anchors.bottom: parent.bottom
    }

    Rectangle {
        objectName: "progressBar"
        anchors.left: parent.left
        anchors.leftMargin: 2
        anchors.top: parent.top
        anchors.topMargin: 1
        height: parent.height - 2
        radius: 3
        smooth: true
        color: indeterminate? "#F09000" : "#368DD4"
        width: indeterminate? parent.width : ((parent.width * value / 100) - 4)
    }
}
