// -*- mode: js; js-indent-level: 4; -*-

.pragma library

// { placeId1 => { timestamp => 1306401785, object => PlaceObject }, placeId2 => ... }

var places = {};

function get (id, timestamp) {
    var place;
    timestamp = timestamp || 0;
    
    //console.log('[places-cache] queried for id ['+id+'] time ['+timestamp+']');

    place = places[id];
    if (place && place.timestamp !== timestamp) {
        //console.log('[places-cache] success, timestamp is ['+place.timestamp+']');
        return place.object;
    } else {
        /*
        console.log('[places-cache] fail');
        if (place) {
            console.log('[places-cache] (aged out)');
        }*/
        return null;
    }
}

function save (id, timestamp, object) {
    //console.log('[places-cache] going to save object for id ['+id+'] time ['+timestamp+']');

    places[id] = { timestamp: timestamp, object: object };
}

function purge () {
    places = {};
}


