import QtQuick 1.0

import com.nokia.meego 1.0

Item {
    id: dialoger

    property variant mainScreen: null

    signal selected(string optionText, variant param)

    function showFavoriteCreateSuccess() {
        queryDialogue.show(qsTranslate("Maps", "qtn_favoritesconnector_favoritesdialoguer_favorite_create_success_caption"), // Create favorite successful
            qsTranslate("Maps", "qtn_favoritesconnector_favoritesdialoguer_favorite_create_success_body") + " \n"); // Create favorite successful.
    }

    function showFavoriteCreateFailed() {
        queryDialogue.show(qsTranslate("Maps", "qtn_favoritesconnector_favoritesdialoguer_favorite_create_failed_caption"), // Create favorite failed
            qsTranslate("Maps", "qtn_favoritesconnector_favoritesdialoguer_favorite_create_failed_body") + " \n"); // Create favorite failed.
    }

    function showFavoriteUpdateSuccess() {
        queryDialogue.show(qsTranslate("Maps", "qtn_favoritesconnector_favoritesdialoguer_favorite_update_success_caption"), // Update favorite successful
            qsTranslate("Maps", "qtn_favoritesconnector_favoritesdialoguer_favorite_update_success_body") + " \n"); // Update favorite successful.
    }

    function showFavoriteUpdateFailed() {
        queryDialogue.show(qsTranslate("Maps", "qtn_favoritesconnector_favoritesdialoguer_favorite_update_failed_caption"), // Update favorite failed
            qsTranslate("Maps", "qtn_favoritesconnector_favoritesdialoguer_favorite_update_failed_body") + " \n"); // Update favorite failed.
    }

    function showFavoriteRemoveSuccess() {
        queryDialogue.show(qsTranslate("Maps", "qtn_favoritesconnector_favoritesdialoguer_favorite_remove_success_caption"), // Remove favorite successful
            qsTranslate("Maps", "qtn_favoritesconnector_favoritesdialoguer_favorite_remove_success_body") + " \n"); // Remove favorite successful.
    }

    function showFavoriteRemoveFailed() {
        queryDialogue.show(qsTranslate("Maps", "qtn_favoritesconnector_favoritesdialoguer_favorite_remove_failed_caption"), // Remove favorite failed
            qsTranslate("Maps", "qtn_favoritesconnector_favoritesdialoguer_favorite_remove_failed_body") + " \n"); // Remove favorite failed.
    }
// TODO: FIX THIS!!!!
//    QueryDialog {
//        id: queryDialogue
//        objectName: "favoritesQueryDialog"

//        parent: dialoger.mainScreen
//        acceptButtonLabel: qsTranslate("Maps", "qtn_favoritesconnector_favoritesdialoguer_cancelbtn") // Cancel
//        rejectButtonLabel: ""

//        onSelected: { dialoger.selected(optionText, param) }
//    }

    Component.onCompleted: {
        var tmpParent = dialoger.mainScreen;
        if (!tmpParent) {
            tmpParent = dialoger;
            while (tmpParent.parent) {
                tmpParent = tmpParent.parent;
            }

            dialoger.mainScreen = tmpParent;
        }
    }
}
