import QtQuick 1.0

Item {
    id: positionMarker

    property int accuracy: 1
    property color itemColor
    property variant mapView

    anchors.topMargin: -15

    Rectangle {
        id: halo

        color: itemColor

        width: dot.width + positionMarker.accuracy * 2
        height: dot.width + positionMarker.accuracy * 2
        radius: dot.radius + positionMarker.accuracy

        opacity: 0.2

        anchors.centerIn: parent

        visible: mainscreen.showAllPositionMarkers
    }

    Rectangle {
        id: dot

        color: itemColor
        width: 30
        height:  30
        radius: 15

        opacity: 0.4

        anchors.centerIn: parent

        visible: mainscreen.showAllPositionMarkers
    }
}
