// -*- mode: js2; espresso-indent-level: 4; -*-

// Constants for maneuvers.
var translatePrefix = "qtn_navigationconnector_maneuverconstants_";
//  qtn_navigationconnector_maneuverconstants_joiner: and

var TURN_UNDEFINED = "maneuver_turn_undefined";
var TURN_NO_TURN = "maneuver_turn_noturn";
var TURN_KEEP_MIDDLE = "maneuver_turn_keepmiddle";
var TURN_KEEP_RIGHT = "maneuver_turn_keepright";
var TURN_KEEP_LEFT = "maneuver_turn_keepleft";
var TURN_LIGHT_RIGHT = "maneuver_turn_lightright";
var TURN_QUITE_RIGHT = "maneuver_turn_quiteright";
var TURN_HEAVY_RIGHT = "maneuver_turn_heavyright";
var TURN_LIGHT_LEFT = "maneuver_turn_lightleft";
var TURN_QUITE_LEFT = "maneuver_turn_quiteleft";
var TURN_HEAVY_LEFT = "maneuver_turn_heavyleft";
var TURN_RETURN = "maneuver_turn_return";
var TURN_ROUNDABOUT_1 = "maneuver_turn_roundabout_exit_1";
var TURN_ROUNDABOUT_2 = "maneuver_turn_roundabout_exit_2";
var TURN_ROUNDABOUT_3 = "maneuver_turn_roundabout_exit_3";
var TURN_ROUNDABOUT_4 = "maneuver_turn_roundabout_exit_4";
var TURN_ROUNDABOUT_5 = "maneuver_turn_roundabout_exit_5";
var TURN_ROUNDABOUT_6 = "maneuver_turn_roundabout_exit_6";
var TURN_ROUNDABOUT_7 = "maneuver_turn_roundabout_exit_7";
var TURN_ROUNDABOUT_8 = "maneuver_turn_roundabout_exit_8";
var TURN_ROUNDABOUT_9 = "maneuver_turn_roundabout_exit_9";
var TURN_ROUNDABOUT_10 = "maneuver_turn_roundabout_exit_10";
var TURN_ROUNDABOUT_11 = "maneuver_turn_roundabout_exit_11";
var TURN_ROUNDABOUT_12 = "maneuver_turn_roundabout_exit_12";

var ICON_GO_STRAIGHT = "IconGoStraight";
var ICON_UNDEFINED = "IconUndefined";
var ICON_UTURN_RIGHT = "IconUturnRight";
var ICON_UTURN_LEFT = "IconUturnLeft";
var ICON_KEEP_MIDDLE = "IconKeepMiddle";
var ICON_KEEP_RIGHT = "IconKeepRight";
var ICON_KEEP_LEFT = "IconKeepLeft";
var ICON_LIGHT_RIGHT = "IconLightRight";
var ICON_LIGHT_LEFT = "IconLightLeft";
var ICON_QUITE_RIGHT = "IconQuiteRight";
var ICON_QUITE_LEFT = "IconQuiteLeft";
var ICON_HEAVY_RIGHT = "IconHeavyRight";
var ICON_HEAVY_LEFT = "IconHeavyLeft";
var ICON_ENTER_MOTORWAY_RIGHT_LANE = "IconEnterMotorwayRightLane";
var ICON_ENTER_MOTORWAY_LEFT_LANE = "IconEnterMotorwayLeftLane";
var ICON_LEAVE_MOTORWAY_RIGHT_LANE = "IconLeaveMotorwayRightLane";
var ICON_LEAVE_MOTORWAY_LEFT_LANE = "IconLeaveMotorwayLeftLane";
var ICON_MOTORWAY_KEEP_RIGHT = "IconMotorwayKeepRight";
var ICON_MOTORWAY_KEEP_LEFT = "IconMotorwayKeepLeft";
var ICON_ROUNDABOUT_1 = "IconRoundabout1";
var ICON_ROUNDABOUT_2 = "IconRoundabout2";
var ICON_ROUNDABOUT_3 = "IconRoundabout3";
var ICON_ROUNDABOUT_4 = "IconRoundabout4";
var ICON_ROUNDABOUT_5 = "IconRoundabout5";
var ICON_ROUNDABOUT_6 = "IconRoundabout6";
var ICON_ROUNDABOUT_7 = "IconRoundabout7";
var ICON_ROUNDABOUT_8 = "IconRoundabout8";
var ICON_ROUNDABOUT_9 = "IconRoundabout9";
var ICON_ROUNDABOUT_10 = "IconRoundabout10";
var ICON_ROUNDABOUT_11 = "IconRoundabout11";
var ICON_ROUNDABOUT_12 = "IconRoundabout12";
var ICON_ROUNDABOUT_1_LH = "IconRoundabout1Lh";
var ICON_ROUNDABOUT_2_LH = "IconRoundabout2Lh";
var ICON_ROUNDABOUT_3_LH = "IconRoundabout3Lh";
var ICON_ROUNDABOUT_4_LH = "IconRoundabout4Lh";
var ICON_ROUNDABOUT_5_LH = "IconRoundabout5Lh";
var ICON_ROUNDABOUT_6_LH = "IconRoundabout6Lh";
var ICON_ROUNDABOUT_7_LH = "IconRoundabout7Lh";
var ICON_ROUNDABOUT_8_LH = "IconRoundabout8Lh";
var ICON_ROUNDABOUT_9_LH = "IconRoundabout9Lh";
var ICON_ROUNDABOUT_10_LH = "IconRoundabout10Lh";
var ICON_ROUNDABOUT_11_LH = "IconRoundabout11Lh";
var ICON_ROUNDABOUT_12_LH = "IconRoundabout12Lh";
var ICON_END = "IconEnd";
var ICON_START = "IconStart";
var ICON_FERRY = "IconFerry";
var ICON_PUBLICTRANSPORT = "IconPublicTransport";

var ICON_INDEX_GO_STRAIGHT = 0;
var ICON_INDEX_UNDEFINED = 1;
var ICON_INDEX_UTURN_RIGHT = 2;
var ICON_INDEX_UTURN_LEFT = 3;
var ICON_INDEX_KEEP_RIGHT = 4;
var ICON_INDEX_KEEP_LEFT = 5;
var ICON_INDEX_LIGHT_RIGHT = 6;
var ICON_INDEX_LIGHT_LEFT = 7;
var ICON_INDEX_QUITE_RIGHT = 8;
var ICON_INDEX_QUITE_LEFT = 9;
var ICON_INDEX_HEAVY_RIGHT = 10;
var ICON_INDEX_HEAVY_LEFT = 11;
var ICON_INDEX_ENTER_MOTORWAY_RIGHT_LANE = 15;
var ICON_INDEX_ENTER_MOTORWAY_LEFT_LANE = 14;
var ICON_INDEX_LEAVE_MOTORWAY_RIGHT_LANE = 16;
var ICON_INDEX_LEAVE_MOTORWAY_LEFT_LANE = 17;
var ICON_INDEX_MOTORWAY_KEEP_RIGHT = 20;
var ICON_INDEX_MOTORWAY_KEEP_LEFT = 21;
var ICON_INDEX_ROUNDABOUT_1 = 22;
var ICON_INDEX_ROUNDABOUT_2 = 23;
var ICON_INDEX_ROUNDABOUT_3 = 24;
var ICON_INDEX_ROUNDABOUT_4 = 25;
var ICON_INDEX_ROUNDABOUT_5 = 26;
var ICON_INDEX_ROUNDABOUT_6 = 27;
var ICON_INDEX_ROUNDABOUT_7 = 28;
var ICON_INDEX_ROUNDABOUT_8 = 29;
var ICON_INDEX_ROUNDABOUT_9 = 30;
var ICON_INDEX_ROUNDABOUT_10 = 31;
var ICON_INDEX_ROUNDABOUT_11 = 32;
var ICON_INDEX_ROUNDABOUT_12 = 33;
var ICON_INDEX_ROUNDABOUT_1_LH = 34;
var ICON_INDEX_ROUNDABOUT_2_LH = 35;
var ICON_INDEX_ROUNDABOUT_3_LH = 36;
var ICON_INDEX_ROUNDABOUT_4_LH = 37;
var ICON_INDEX_ROUNDABOUT_5_LH = 38;
var ICON_INDEX_ROUNDABOUT_6_LH = 39;
var ICON_INDEX_ROUNDABOUT_7_LH = 40;
var ICON_INDEX_ROUNDABOUT_8_LH = 41;
var ICON_INDEX_ROUNDABOUT_9_LH = 42;
var ICON_INDEX_ROUNDABOUT_10_LH = 43;
var ICON_INDEX_ROUNDABOUT_11_LH = 44;
var ICON_INDEX_ROUNDABOUT_12_LH = 45;
var ICON_INDEX_END = 46;
var ICON_INDEX_START = 47;
var ICON_INDEX_FERRY = 48;
var ICON_INDEX_KEEP_MIDDLE = 56;
var ICON_INDEX_WALK_MANEUVER = 64;
var ICON_INDEX_PUBLICTRANSPORT = 128;

var ACTION_UNDEFINED = "maneuver_action_undefined";
var ACTION_NO_ACTION = "maneuver_action_noaction";
var ACTION_END = "maneuver_action_end";
var ACTION_STOPOVER = "maneuver_action_stopover";
var ACTION_JUNCTION = "maneuver_action_junction";
var ACTION_ROUNDABOUT = "maneuver_action_roundabout";
var ACTION_UTURN = "maneuver_action_uturn";
var ACTION_ENTER_HIGHWAY = "maneuver_action_enterhighway";
var ACTION_ENTER_HIGHWAY_FROM_RIGHT = "maneuver_action_enterhighwayfromright";
var ACTION_ENTER_HIGHWAY_FROM_LEFT = "maneuver_action_enterhighwayfromleft";
var ACTION_PASS_JUNCTION = "maneuver_action_passjunction";
var ACTION_LEAVE_HIGHWAY = "maneuver_action_leavehighway";
var ACTION_CHANGE_HIGHWAY = "maneuver_action_changehighway";
var ACTION_CONTINUE_HIGHWAY = "maneuver_action_continuehighway";
var ACTION_FERRY = "maneuver_action_ferry";
var ACTION_ENTER_STATION = "maneuver_action_enterstation";
var ACTION_LEAVE_STATION = "maneuver_action_leavestation";

var TYPE_WALK = "walk segment";
var TYPE_WALK_APPROACHING = "walk segment approaching pt stop";
var TYPE_ENTER = "enter";
var TYPE_EXIT = "exit";

var TRANSPORT_BUS_PUBLIC = "bus_public";
var TRANSPORT_BUS_TOURISTIC = "bus_touristic";
var TRANSPORT_BUS_INTERCITY = "bus_intercity";
var TRANSPORT_BUS_EXPRESS = "bus_express";
var TRANSPORT_RAIL_METRO = "rail_metro";
var TRANSPORT_RAIL_LIGHT = "rail_light";
var TRANSPORT_RAIL_REGIONAL = "rail_regional";
var TRANSPORT_TRAIN_REGIONAL = "train_regional";
var TRANSPORT_TRAIN_INTERCITY = "train_intercity";
var TRANSPORT_TRAIN_HIGH_SPEED = "train_highspeed";
var TRANSPORT_MONORAIL = "monorail";
var TRANSPORT_AERIAL = "aerial";
var TRANSPORT_INCLINED = "inclined";
var TRANSPORT_WATER = "water";

var CATEGORY_BUS = "bus";
var CATEGORY_TRAIN = "train";
var CATEGORY_FERRY = "ferry";

var FOW_PEDESTRIAN_WALKWAY = "fow.pedestrian_walkway"

var MANEUVER_ICON_INDEXES;
var MANEUVER_TURNS;
var MANEUVER_ACTIONS;

function createManeuverIconIndexMap() {
    if(!MANEUVER_ICON_INDEXES || MANEUVER_ICON_INDEXES.length === 0) {
        MANEUVER_ICON_INDEXES = [];
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_GO_STRAIGHT] = ICON_INDEX_GO_STRAIGHT;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_UNDEFINED] = ICON_INDEX_UNDEFINED;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_UTURN_RIGHT] = ICON_INDEX_UTURN_RIGHT;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_UTURN_LEFT] = ICON_INDEX_UTURN_LEFT;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_KEEP_RIGHT] = ICON_INDEX_KEEP_RIGHT;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_KEEP_LEFT] = ICON_INDEX_KEEP_LEFT;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_LIGHT_RIGHT] = ICON_INDEX_LIGHT_RIGHT;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_LIGHT_LEFT] = ICON_INDEX_LIGHT_LEFT;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_QUITE_RIGHT] = ICON_INDEX_QUITE_RIGHT;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_QUITE_LEFT] = ICON_INDEX_QUITE_LEFT;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_HEAVY_RIGHT] = ICON_INDEX_HEAVY_RIGHT;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_HEAVY_LEFT] = ICON_INDEX_HEAVY_LEFT;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ENTER_MOTORWAY_RIGHT_LANE] =
                ICON_INDEX_ENTER_MOTORWAY_RIGHT_LANE;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ENTER_MOTORWAY_LEFT_LANE] =
                ICON_INDEX_ENTER_MOTORWAY_LEFT_LANE;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_LEAVE_MOTORWAY_RIGHT_LANE] =
                ICON_INDEX_LEAVE_MOTORWAY_RIGHT_LANE;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_LEAVE_MOTORWAY_LEFT_LANE] = ICON_INDEX_LEAVE_MOTORWAY_LEFT_LANE;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_MOTORWAY_KEEP_RIGHT] = ICON_INDEX_MOTORWAY_KEEP_RIGHT;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_MOTORWAY_KEEP_LEFT] = ICON_INDEX_MOTORWAY_KEEP_LEFT;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_1] = ICON_INDEX_ROUNDABOUT_1;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_2] = ICON_INDEX_ROUNDABOUT_2;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_3] = ICON_INDEX_ROUNDABOUT_3;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_4] = ICON_INDEX_ROUNDABOUT_4;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_5] = ICON_INDEX_ROUNDABOUT_5;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_6] = ICON_INDEX_ROUNDABOUT_6;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_7] = ICON_INDEX_ROUNDABOUT_7;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_8] = ICON_INDEX_ROUNDABOUT_8;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_9] = ICON_INDEX_ROUNDABOUT_9;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_10] = ICON_INDEX_ROUNDABOUT_10;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_11] = ICON_INDEX_ROUNDABOUT_11;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_12] = ICON_INDEX_ROUNDABOUT_12;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_1_LH] = ICON_INDEX_ROUNDABOUT_1_LH;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_2_LH] = ICON_INDEX_ROUNDABOUT_2_LH;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_3_LH] = ICON_INDEX_ROUNDABOUT_3_LH;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_4_LH] = ICON_INDEX_ROUNDABOUT_4_LH;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_5_LH] = ICON_INDEX_ROUNDABOUT_5_LH;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_6_LH] = ICON_INDEX_ROUNDABOUT_6_LH;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_7_LH] = ICON_INDEX_ROUNDABOUT_7_LH;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_8_LH] = ICON_INDEX_ROUNDABOUT_8_LH;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_9_LH] = ICON_INDEX_ROUNDABOUT_9_LH;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_10_LH] = ICON_INDEX_ROUNDABOUT_10_LH;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_11_LH] = ICON_INDEX_ROUNDABOUT_11_LH;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_ROUNDABOUT_12_LH] = ICON_INDEX_ROUNDABOUT_12_LH;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_END] = ICON_INDEX_END;
        MANEUVER_ICON_INDEXES[/*MapsPlugin.Maneuver.ICON_WALK*/64] = ICON_INDEX_WALK_MANEUVER;
        MANEUVER_ICON_INDEXES[MapsPlugin.Maneuver.ICON_FERRY] = ICON_INDEX_FERRY;
    }
}

function createManeuverTurnMap() {
    if(!MANEUVER_TURNS || MANEUVER_TURNS.length === 0) {
    MANEUVER_TURNS = [];
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_UNDEFINED] = TURN_UNDEFINED;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_NO_TURN] = TURN_NO_TURN;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_KEEP_MIDDLE] = TURN_KEEP_MIDDLE;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_KEEP_RIGHT] = TURN_KEEP_RIGHT;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_LIGHT_RIGHT] = TURN_LIGHT_RIGHT;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_QUITE_RIGHT] = TURN_QUITE_RIGHT;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_HEAVY_RIGHT] = TURN_HEAVY_RIGHT;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_KEEP_LEFT] = TURN_KEEP_LEFT;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_LIGHT_LEFT] = TURN_LIGHT_LEFT;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_QUITE_LEFT] = TURN_QUITE_LEFT;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_HEAVY_LEFT] = TURN_HEAVY_LEFT;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_RETURN] = TURN_RETURN;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_ROUNDABOUT_1] = TURN_ROUNDABOUT_1;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_ROUNDABOUT_2] = TURN_ROUNDABOUT_2;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_ROUNDABOUT_3] = TURN_ROUNDABOUT_3;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_ROUNDABOUT_4] = TURN_ROUNDABOUT_4;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_ROUNDABOUT_5] = TURN_ROUNDABOUT_5;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_ROUNDABOUT_6] = TURN_ROUNDABOUT_6;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_ROUNDABOUT_7] = TURN_ROUNDABOUT_7;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_ROUNDABOUT_8] = TURN_ROUNDABOUT_8;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_ROUNDABOUT_9] = TURN_ROUNDABOUT_9;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_ROUNDABOUT_10] = TURN_ROUNDABOUT_10;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_ROUNDABOUT_11] = TURN_ROUNDABOUT_11;
        MANEUVER_TURNS[MapsPlugin.Maneuver.TURN_ROUNDABOUT_12] = TURN_ROUNDABOUT_12;
    }
}

function createManeuverActionMap() {
        MANEUVER_ACTIONS = [];

        MANEUVER_ACTIONS[MapsPlugin.Maneuver.ACTION_UNDEFINED] = ACTION_UNDEFINED;
        MANEUVER_ACTIONS[MapsPlugin.Maneuver.ACTION_NO_ACTION] = ACTION_NO_ACTION;
        MANEUVER_ACTIONS[MapsPlugin.Maneuver.ACTION_END] = ACTION_END;
        MANEUVER_ACTIONS[MapsPlugin.Maneuver.ACTION_STOPOVER] = ACTION_STOPOVER;
        MANEUVER_ACTIONS[MapsPlugin.Maneuver.ACTION_JUNCTION] = ACTION_JUNCTION;
        MANEUVER_ACTIONS[MapsPlugin.Maneuver.ACTION_ROUNDABOUT] = ACTION_ROUNDABOUT;
        MANEUVER_ACTIONS[MapsPlugin.Maneuver.ACTION_UTURN] = ACTION_UTURN;
        MANEUVER_ACTIONS[MapsPlugin.Maneuver.ACTION_ENTER_HIGHWAY] = ACTION_ENTER_HIGHWAY;
        MANEUVER_ACTIONS[MapsPlugin.Maneuver.ACTION_ENTER_HIGHWAY_FROM_RIGHT] = ACTION_ENTER_HIGHWAY_FROM_RIGHT;
        MANEUVER_ACTIONS[MapsPlugin.Maneuver.ACTION_ENTER_HIGHWAY_FROM_LEFT] = ACTION_ENTER_HIGHWAY_FROM_LEFT;
        MANEUVER_ACTIONS[MapsPlugin.Maneuver.ACTION_PASS_JUNCTION] = ACTION_PASS_JUNCTION;
        MANEUVER_ACTIONS[MapsPlugin.Maneuver.ACTION_LEAVE_HIGHWAY] = ACTION_LEAVE_HIGHWAY;
        MANEUVER_ACTIONS[MapsPlugin.Maneuver.ACTION_CHANGE_HIGHWAY] = ACTION_CHANGE_HIGHWAY;
        MANEUVER_ACTIONS[MapsPlugin.Maneuver.ACTION_CONTINUE_HIGHWAY] = ACTION_CONTINUE_HIGHWAY;
        MANEUVER_ACTIONS[MapsPlugin.Maneuver.ACTION_FERRY] = ACTION_FERRY;
        // currently not all maneuvers contain the following two constants.
        MANEUVER_ACTIONS[/*MapsPlugin.Maneuver.ACTION_ENTER_STATION*/15] = ACTION_ENTER_STATION;
        MANEUVER_ACTIONS[/*MapsPlugin.Maneuver.ACTION_LEAVE_STATION*/16] = ACTION_LEAVE_STATION;
}

/**
 * Function for parsing the maneuver description from action & turn.
 * This is a quick fix to make use of the text pieces we have now.
 * There may be languages where this approach does not work (Japanese
 * comes to mind) but it's a better solution than concatenating strings
 * automatically. Separate translations have to be defined for phrases
 * with and without street name, because both cases occur in normal usage.
 *
 * @param {boolean} aUseStreet Whether to include street names in descriptions
 * @param {array}   aFormat Formatting of street/signpost names with placeholders:
 *             e.g. {street: "<span class='foo'>{0}</span>", signpost: "<b>{0}</b>"}
 *
 * @returns {string} The maneuver description with possible street/signpost names
 */
function getDescription(aManeuver, aUseStreet, aFormat) {
    log.trace(" ================================= MANEUVER INFO =================================");
    createManeuverActionMap();
    createManeuverTurnMap();
    // these placeholders are defined in translation strings
    var streetPlaceholder = "{0}";
    var signpostPlaceholder = "{1}";

    var actionKey = aManeuver.action;
    var turnKey = aManeuver.turn;

    // since there is only one field per format, the placeholder is always zero
    var formatPlaceholder = "{0}";

    var descriptions = [];
    var description;
    var street = aManeuver.streetName || aManeuver.routeName;

    switch (aManeuver.action) {
        // Roundabouts: Join action and turn without a conjunction
    case MapsPlugin.Maneuver.ACTION_ROUNDABOUT:
        descriptions.push(_translatePart(MANEUVER_ACTIONS[actionKey], false));
        descriptions.push(_translatePart(MANEUVER_TURNS[turnKey], aUseStreet));
        description = descriptions.join(" ");
        break;

        // Junctions: only display the turn
    case MapsPlugin.Maneuver.ACTION_JUNCTION:
        description = _translatePart(MANEUVER_TURNS[turnKey], aUseStreet);
        break;

        // Actions related to highways: turn comes before the action
    case MapsPlugin.Maneuver.ACTION_ENTER_HIGHWAY:
    case MapsPlugin.Maneuver.ACTION_ENTER_HIGHWAY_FROM_LEFT:
    case MapsPlugin.Maneuver.ACTION_ENTER_HIGHWAY_FROM_RIGHT:
    case MapsPlugin.Maneuver.ACTION_LEAVE_HIGHWAY:
    case MapsPlugin.Maneuver.ACTION_CONTINUE_HIGHWAY:
    case MapsPlugin.Maneuver.ACTION_CHANGE_HIGHWAY:
        log.trace(" aManeuver.routeName: " + aManeuver.routeName);
        log.trace(" aManeuver.nextRouteName: " + aManeuver.nextRouteName);
        log.trace(" aManeuver.signpost.exitNumber: " + aManeuver.signpost.exitNumber);
        log.trace(" aManeuver.signpost.exitText: " + aManeuver.signpost.exitText);
        log.trace(" aManeuver.signpost.exitDirections: " + aManeuver.signpost.exitDirections);
        description = _translatePart(MANEUVER_ACTIONS[actionKey], false);
        break;
    case MapsPlugin.Maneuver.ACTION_ENTER_STATION:
    case MapsPlugin.Maneuver.ACTION_LEAVE_STATION:
        description = _translatePart(MANEUVER_ACTIONS[actionKey], false, {
                                     "0": aManeuver.lineName,
                                     "1": aManeuver.stationName,
                                     "2": aManeuver.arrivalStationName
    });

        aUseStreet = false;
        break;


        // Anything else: action comes before the turn
        // these have no turns: ACTION_UNDEFINED, ACTION_END, ACTION_FERRY, ACTION_UTURN, ACTION_STOPOVER
        // these come with turns: ACTION_PASS_JUNCTION
    default:
        descriptions.push(_translatePart(MANEUVER_ACTIONS[actionKey], aUseStreet));

        // currently only occurs with ACTION_PASS_JUNCTION
//        if (aManeuver.action === MapsPlugin.Maneuver.ACTION_PASS_JUNCTION) {
//            var turnTrans = _translatePart(MANEUVER_TURNS[turnKey], aUseStreet);

//            if (turnTrans) {
//                descriptions.push(turnTrans);
//            }
//        }

        if (descriptions.length) {
            description = descriptions.join(" " + qsTranslate("Maps", translatePrefix + "joiner") + " ");
        } else {
            // shouldn't happen if translations are up to date
            description = "";
        }

    }
    if (description) {
        description = description.charAt(0).toUpperCase() + description.substring(1);
    } else {
        return "";
    }

    if (aUseStreet) {
        if (aFormat && aFormat.street) {
            street = aFormat.street.replace(formatPlaceholder, street);
        }

        if (description.indexOf(streetPlaceholder) === -1) {
            description += " " + street;
        } else {
            description = description.replace(streetPlaceholder, street);
        }
    }
    log.trace(" next street name: " + aManeuver.nextStreetName);
    log.trace(" returning: \n" + description);
    log.trace(" =================================================================================");
    return description;
}

function _translatePart(aPartString, aUseStreet, aVariables) {
    if (!aPartString) {
        return "";
    }
//    var key = aPartString + (aUseStreet ? ".street" : "");
//    var str = qsTranslate("Maps", key, aVariables);

//    print("*********************************** Routing error %1 (%2)".arg(
//        errorCode).arg(RoutingUtils.getErrorText(errorCode)));
    var str = qsTranslate("Maps", translatePrefix + aPartString);
//    if(aUseStreet) {
//        str = qsTranslate("Maps", "" + translatePrefix + aPartString).arg("qtn_navigationconnector_maneuverconstants_on");
//    }


    if (str === "undefined") {
        return "";
    }

    return str;
};

// Mention all possible generated translations once to make lrelease not remove them inadvertendly
if (false) {
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_on');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_roundabout_exit_1');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_roundabout_exit_2');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_roundabout_exit_3');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_roundabout_exit_4');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_roundabout_exit_5');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_roundabout_exit_6');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_roundabout_exit_7');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_roundabout_exit_8');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_roundabout_exit_9');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_roundabout_exit_10');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_roundabout_exit_11');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_roundabout_exit_12');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_return');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_heavyleft');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_quiteleft');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_lightleft');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_heavyright');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_quiteright');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_lightright');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_keepleft');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_keepright');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_keepmiddle');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_turn_noturn');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_action_undefined');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_action_noaction');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_action_end');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_action_stopover');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_action_roundabout');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_action_uturn');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_action_enterhighway');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_action_enterhighwayfromright');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_action_enterhighwayfromleft');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_action_passjunction');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_action_leavehighway');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_action_changehighway');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_action_continuehighway');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_action_ferry');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_action_enterstation');
    qsTranslate('Maps', 'qtn_navigationconnector_maneuverconstants_maneuver_action_leavestation');
    qsTranslate('Maps', 'qtn_navigationconnector_infobubble_go');
    qsTranslate('Maps', 'qtn_navigationconnector_routeplanner_route_error_notsupported');
    qsTranslate('Maps', 'qtn_navigationconnector_previewviewmenu_audiocommands');
    qsTranslate('Maps', 'qtn_navigationconnector_previewviewmenu_audiosettings');
    qsTranslate('Maps', 'qtn_navigationconnector_preview_to');
}

function getPtGeneralIconByTransitType(aType) {
    var type;
    switch (aType) {
        case TransitLineInfo.TRANSIT_TYPE_BUS_PUBLIC:
        case TransitLineInfo.TRANSIT_TYPE_BUS_TOURISTIC:
        case TransitLineInfo.TRANSIT_TYPE_BUS_INTERCITY:
        case TransitLineInfo.TRANSIT_TYPE_BUS_EXPRESS:
            type = "bus";
            break;
        case TransitLineInfo.TRANSIT_TYPE_RAIL_METRO:
            type = "rail_citymetro";
            break;
        case TransitLineInfo.TRANSIT_TYPE_RAIL_LIGHT:
            type = "rail_light";
            break;
        case TransitLineInfo.TRANSIT_TYPE_RAIL_REGIONAL:
            type = "rail_regional";
            break;
        case TransitLineInfo.TRANSIT_TYPE_TRAIN_REGIONAL:
        case TransitLineInfo.TRANSIT_TYPE_TRAIN_INTERCITY:
        case TransitLineInfo.TRANSIT_TYPE_TRAIN_HIGH_SPEED :
            type = "train";
            break;
        case TransitLineInfo.TRANSIT_TYPE_MONORAIL:
            type = "rail_regional";
            break;
        case TransitLineInfo.TRANSIT_TYPE_AERIAL:
        case TransitLineInfo.TRANSIT_TYPE_INCLINED:
        case TransitLineInfo.TRANSIT_TYPE_WATER:
            type = "rail_regional";
            break;
    }

    if (type) {
        return placesAssetsPath + "images/categories/mobile_list_public_transport_" + type + ".png";
    }
    return "";
};
