import QtQuick 1.0

import "pages" as Pages

Pages.RoutePreview {
    id: routeCreatorFlow

    property Route result

    Component {
        id: newRoute
        Route {
            mode: "drive"
        }
    }

    onForward: {
        result = route;
        routeCreatorFlow.finished(error, result);
    }

    Component.onCompleted: {
        if (!model) {
            model = newRoute.createObject(Qt);
        }
    }
}
