// -*- mode: js; js-indent-level: 4; -*-
.pragma library

function _log (message, trace) {
    message = '[places] ' + message;

    /*if (typeof log != "undefined"){
        if (trace) {
            log.trace(message);
        } else {
            log.info(message);
        }
    }*/
}

function getIconUrlStatic(mode, category, isFav, ppFlag, assetsPath) {
    var iconPath = assetsPath + "images/categories/mobile_";
    var iconMode = (mode == "list"? "list_" : "map_");
    var iconCategory = category || "default";
    var iconSuffix = ".png";

    // ppFlag & 2: proves the prime Flag. PrimePlaces can have ppFlags of (2^n+2 || 2^n+2+1) ppFlags like 2, 3, 6, 7, 10, 11, 18, 19, ...
    var isPrime = ppFlag & 2;

    if (isFav){
        iconSuffix = "_fav.png";
    } else if (isPrime){
        iconSuffix = "_pp.png";
    } //else ".png

    return iconPath + iconMode + iconCategory + iconSuffix;
}

function getIconSourceFromCategoryNameStatic(aName, ppFlag, isFav, mode, assetsPath) {
    _log("name: " + aName + ", isFav: " + isFav);
    var mainCategory;
    var categoryMapping = {
        "131": {id:"eat-drink",  names: ["restaurant", "bar-pub", "coffee-tea", "snacks-fast-food","eat-drink","food-drink"]},
        "132": {id:"goingout", names: ["theatre-music-culture","casino","cinema","dance-night-club","going-out"]},
        "133": {id:"sights-museums", names:["landmark-attraction","museum","sights-museums"]},
        "134": {id:"transport", names: ["airport", "car-dealer-repair", "car-rental","ferry-terminal","petrol-station","public-transport","railway-station","taxi-stand","transport"]},
        "135": {id:"accomodation", names: ["accommodation","hostel","hotel","motel"]},
        "136": {id:"shopping", names: ["bookshop","clothing-accessories-shop","department-store","electronics-shop","hardware-house-garden-shop","kiosk-convenience-store","mall","shop","shopping","sport-outdoor-shop"]},
        "137": {id:"business-services", names: ["atm-bank-exchange", "business-services", "business-industry","pharmacy","police-emergency","post-office","religious-place","service","tourist-information","travel-agency"]},
        "138": {id:"facility", names: ["building","communication-media","education-facility","facilities","facility","fair-convention-facility","government-community-facility","hospital-health-care-facility","outdoor-area-complex","parking-facility","sports-facility-venue"]},
        "139": {id:"leisure", names: ["amusement-holiday-park", "camping","leisure-outdoor","recreation"]},
        "140": {id:"areas-infrastructure", names:["administrative-region","library"]},
        "141": {id: "nature-geography",names:["body-of-water","city-town-village","forest-heath-vegetation","mountain-hill","undersea-feature"]}
    }

    for (var i in categoryMapping) {
        if (categoryMapping.hasOwnProperty(i)) {
            if (categoryMapping[i].names.indexOf(aName) > -1) {
                return getIconUrlStatic(mode, (categoryMapping[i].id.replace("-", "_")), isFav, ppFlag, assetsPath);
            }
        }
    }
    return getIconUrlStatic(mode, 0, isFav, ppFlag, assetsPath);
}
