import QtQuick 1.0
import ovi.connector 1.0

Item {
    id: rect
    property variant place
    visible: place && place.isFavorite

    property variant favoriteText

    anchors {
        left: parent.left
        right: parent.right
    }
    height: headerArea.height + descriptionArea.paintedHeight +10 //was +30 before, was a bit too much

    OviListHeader {
        id: headerArea
        headerText: qsTranslate("Maps", "qtn_placesconnector_favorite_description") // My description
        objectName: "personalizeHeader"
    }


    MapsText {
        id: descriptionArea
        objectName: "favDescriptionArea"

        anchors {
            left: parent.left
            right: parent.right
            top: headerArea.bottom
            leftMargin: 10
            rightMargin: 10
        }

        state: "normalWrap"

        text: favoriteText? favoriteText : qsTranslate("Maps", "qtn_placesconnector_favorite_nodescription")
    }
}
