import QtQuick 1.0
import ovi.connector 1.0

Item{
    property alias caption:headline.text
    property alias text:inside.text

    visible: !!text;
    onVisibleChanged: if (visible==true) detailsShown = true;

    height: headline.height + (!!text ? inside.height : 0) + 26
    anchors { left:parent.left; right:parent.right; leftMargin: 17; rightMargin:10; topMargin:16; }

    MapsText {
            id: headline
            elide: Text.ElideRight
            state: "listLarge"


            anchors {left: parent.left; right: parent.right }
    }
    MapsText {
            id: inside
            wrapMode: Text.WordWrap
            textFormat: Text.RichText
            state: "listSmall"

            anchors {top: headline.bottom; left: parent.left; right: parent.right; topMargin: 10 }
    }

}
