import QtQuick 1.0

import com.nokia.meego 1.0
import com.nokia.extras 1.0

QueryDialog {
    id: root

    titleText: "\n" + qsTranslate("Maps", "qtn_maps_custom_disclaimer_caption")
    message: qsTranslate("Maps", "qtn_maps_custom_disclaimer_body") + "<br/><br/>" +
             "<p align=\"left\">" +
                "<a href=\"http://nokia.mobi/privacy/services/terms/nokia-service\">" +
                    "<font size=\"4\" color=\"#0000ff\">" + qsTranslate("Maps", "qtn_maps_custom_disclaimer_privacy_link") + "</font>" +
                "</a>" +
             "</p>" + "<br/>" +
             "<p align=\"left\">" +
                 "By continuing you confirm that you have read and agree to the [1] and [2]. "/*qsTranslate("Maps", "qtn_maps_custom_disclaimer_privacy_link")*/.replace(
                     "[1]",
                     "<a href=\"http://nokia.mobi/privacy/policy\">" +
                         "<font size=\"4\" color=\"#0000ff\">" + qsTranslate("Maps", "qtn_maps_custom_disclaimer_terms_link") + "</font>" +
                     "</a>"
                 ).replace(
                     "[2]",
                     "<a href=\"http://nokia.mobi/privacy/services/map-apps\">" +
                         "<font size=\"4\" color=\"#0000ff\">" + qsTranslate("Maps", "qtn_maps_custom_disclaimer_policy_link") + "</font>" +
                     "</a>"
                 ) +
             "</p>"
    acceptButtonText: qsTranslate("NPS", "qtn_nps_feedback_accept")
    rejectButtonText: qsTranslate("NPS", "qtn_nps_feedback_cancel")

    onLinkActivated: Qt.openUrlExternally(link)
}
