import QtQuick 1.0

Rectangle {
    id: mainscreen

    width: 854;
    height: 480;
    x: 0;
    y: 0;

    //  1st
    //.............
    TextInput {
        y: 10
        x: 0

        id: textInput1
        text: "geo:59.4366,24.7686?action=showOnMap"
        font.pixelSize: 24
        font.bold: true
        autoScroll: true
        width: 700
        Rectangle {
            anchors.fill: parent
            opacity: 0.3
            color: "yellow"
        }
    }

    Rectangle {
        id: button1
        anchors.left: textInput1.right;
        anchors.top: textInput1.top;
        width: textInput1.height + 10;
        height: textInput1.height + 10;
        color: "red"
        border.color: "black"
        border.width: 5
        radius: 10

        MouseArea {
            anchors.fill: parent
            onClicked: {
                button1.color = "green";
                Qt.openUrlExternally(textInput1.text);
            }
        }
    }

    //  2nd
    //.............
    TextInput {
        anchors.left: textInput1.left;
        y: textInput1.y + textInput1.height + 20;

        id: textInput2
        text: "geo:59.4366,24.7686?action=driveTo"
        font.pixelSize: 24
        font.bold: true
        autoScroll: true
        width: 700
        Rectangle {
            anchors.fill: parent
            opacity: 0.3
            color: "yellow"
        }
    }

    Rectangle {
        id: button2
        anchors.left: textInput2.right;
        anchors.top: textInput2.top;
        width: textInput2.height + 10;
        height: textInput2.height + 10;
        color: "red"
        border.color: "black"
        border.width: 5
        radius: 10

        MouseArea {
            anchors.fill: parent
            onClicked: {
                button2.color = "green";
                Qt.openUrlExternally(textInput2.text);
            }
        }
    }

    //  3rd
    //.............
    TextInput {
        anchors.left: textInput2.left;
        y: textInput2.y + textInput2.height + 20;

        id: textInput3
        text: "geo:52.50103530474007,13.307444751262665?action=walkTo"
        font.pixelSize: 24
        font.bold: true
        autoScroll: true
        width: 700
        Rectangle {
            anchors.fill: parent
            opacity: 0.3
            color: "yellow"
        }
    }

    Rectangle {
        id: button3
        anchors.left: textInput3.right;
        anchors.top: textInput3.top;
        width: textInput3.height + 10;
        height: textInput3.height + 10;
        color: "red"
        border.color: "black"
        border.width: 5
        radius: 10

        MouseArea {
            anchors.fill: parent
            onClicked: {
                button3.color = "green";
                Qt.openUrlExternally(textInput3.text);
            }
        }
    }

    //  4th
    //.............
    TextInput {
        anchors.left: textInput3.left;
        y: textInput3.y + textInput3.height + 20;

        id: textInput4
        text: "geo:52.50103530474007,13.307444751262665?action=showPlaceDetails&placeId=276u33db-583576afbb634984afe806a1604dabf9"
        font.pixelSize: 24
        font.bold: true
        autoScroll: true
        width: 700
        Rectangle {
            anchors.fill: parent
            opacity: 0.3
            color: "yellow"
        }
    }

    Rectangle {
        id: button4
        anchors.left: textInput4.right;
        anchors.top: textInput4.top;
        width: textInput4.height + 10;
        height: textInput4.height + 10;
        color: "red"
        border.color: "black"
        border.width: 5
        radius: 10

        MouseArea {
            anchors.fill: parent
            onClicked: {
                button4.color = "green";
                Qt.openUrlExternally(textInput4.text);
            }
        }
    }

    //  5th
    //.............
    TextInput {
        anchors.left: textInput4.left;
        y: textInput4.y + textInput4.height + 20;

        id: textInput5
        text: "geo:0,0?searchTerm='DEU Berlin Invalidenstrasse 117'&action=driveTo"
        font.pixelSize: 24
        font.bold: true
        autoScroll: true
        width: 700
        Rectangle {
            anchors.fill: parent
            opacity: 0.3
            color: "yellow"
        }
    }

    Rectangle {
        id: button5
        anchors.left: textInput5.right;
        anchors.top: textInput5.top;
        width: textInput5.height + 10;
        height: textInput5.height + 10;
        color: "red"
        border.color: "black"
        border.width: 5
        radius: 10

        MouseArea {
            anchors.fill: parent
            onClicked: {
                button5.color = "green";
                Qt.openUrlExternally(textInput5.text);
            }
        }
    }

    //  6th
    //.............
    TextInput {
        anchors.left: textInput5.left;
        y: textInput5.y + textInput5.height + 20;

        id: textInput6
        text: "geo:59.4366,24.7686?action=fakeAction6"
        font.pixelSize: 24
        font.bold: true
        autoScroll: true
        width: 700
        Rectangle {
            anchors.fill: parent
            opacity: 0.3
            color: "yellow"
        }
    }

    Rectangle {
        id: button6
        anchors.left: textInput6.right;
        anchors.top: textInput6.top;
        width: textInput6.height + 10;
        height: textInput6.height + 10;
        color: "red"
        border.color: "black"
        border.width: 5
        radius: 10

        MouseArea {
            anchors.fill: parent
            onClicked: {
                button6.color = "green";
                Qt.openUrlExternally(textInput6.text);
            }
        }
    }

    //  7th
    //.............
    TextInput {
        anchors.left: textInput6.left;
        y: textInput6.y + textInput6.height + 20;

        id: textInput7
        text: "geo:59.4366,24.7686?action=fakeAction7"
        font.pixelSize: 24
        font.bold: true
        autoScroll: true
        width: 700
        Rectangle {
            anchors.fill: parent
            opacity: 0.3
            color: "yellow"
        }
    }

    Rectangle {
        id: button7
        anchors.left: textInput7.right;
        anchors.top: textInput7.top;
        width: textInput7.height + 10;
        height: textInput7.height + 10;
        color: "red"
        border.color: "black"
        border.width: 5
        radius: 10

        MouseArea {
            anchors.fill: parent
            onClicked: {
                button7.color = "green";
                Qt.openUrlExternally(textInput7.text);
            }
        }
    }

}
