import QtQuick 1.0
import ovi.connector 1.0

Row {
    property alias firstLineText: header.text
    property alias secondLineText: content.text

    spacing: 5
    width: parent.width

    MapsText {
        id: copyTag
        text:"©"
        state: "listNormal"
    }

    Column {

        width: parent.width - copyTag.width

        MapsText {
            id: header
            state: "listNormalWrap"
        }

        MapsText {
            id: content
            state: "listNormalWrap"
            width: parent.width
            wrapMode: Text.Wrap
            elide: "ElideNone"
        }
    }
}
