import QtQuick 1.0

import com.nokia.meego 1.0

import ovi.connector 1.0

Item {
    anchors.fill: parent

    Rectangle {
        anchors.fill: parent
        opacity: 0.9
        color: "#000"
    }
    MapsText {
        id: line1
        state: "listNormalBold"
        anchors {
            horizontalCenter: parent.horizontalCenter
            top: parent.top
            topMargin: parent.height*0.25
        }
        platformStyle: LabelStyle {textColor: "#FFF" }
        text: qsTranslate("Maps", "qtn_maps_close_maps")

        elide: "ElideNone"
    }
    MapsText {
        id: line2
        state: "listNormalWrap"
        text: qsTranslate("Maps", "qtn_maps_close_massstorage_warning")
        horizontalAlignment: Text.AlignHCenter
        anchors {
            top: line1.bottom
            topMargin: 20

        }
        width: parent.width
        platformStyle: LabelStyle {textColor: "#FFF" }
        elide: "ElideNone"
    }

    Button {
        text: qsTranslate("Maps", "qtn_maps_close_button")
        anchors {
            horizontalCenter: parent.horizontalCenter
            top: line2.bottom
            topMargin: 60
        }
        platformStyle: ButtonStyle {inverted: true}
        onClicked: { Qt.quit() }
    }
}
