import QtQuick 1.0

import com.nokia.meego 1.0

// ConnectorPage - a page with a reference to the PageStack it is pushed to.
// Important for defining a flow of pages.
// A flow should emit some sort of 'finished' signal on the starting page when done.
Page {
    id: connectorPage

    height: parent ? parent.height : 100
    width: parent ? parent.width : 100

    /// Reference to the connected list or connectedobject
    property QtObject model
    /// Created or picked object
    property QtObject result
    /// Signal emitted when this flow is finished
    signal finished(variant error, variant result)

    // Internally used pageStack
    //  [ACE]: this should be inherited from the Page
//    property QtObject pageStack
}
