import QtQuick 1.0
import ovi.connector 1.0

Item {
    id: root

    anchors {
        left: parent.left
        right: parent.right
        leftMargin: 16
        rightMargin: 10
    }
    height: 62

    property alias headerText: header.text

    MapsText {
        id: header
        state: "listHeader"
        anchors {
            right: parent.right
            verticalCenter: parent.verticalCenter
        }
    }

    Rectangle {
        id: darkLine
        anchors {
            left: parent.left
            right: header.left
            rightMargin: 16
            verticalCenter: parent.verticalCenter
        }
        height: 1
        color: "#e4e5e6"
        Rectangle {
            id: lightLine
            anchors {
                left: parent.left
                right: parent.right
                top: darkLine.bottom
                leftMargin: 4
            }
            height: 1
            color: "#ffffff"
        }
    }
}
