import QtQuick 1.0

Item {
    id: roundedCorners

    anchors.fill: parent
    height: parent.height
    width:parent.width

    Image {
        id: cornerTopLeft
        source: placesAssetsPath + "images/layout/corner-top-left.png"
        anchors.top: parent.top
        anchors.left: parent.left
    }
    Image {
        id: cornerTopRight
        source: placesAssetsPath + "images/layout/corner-top-right.png"
        anchors.top: parent.top
        anchors.right: parent.right
    }
    Image {
        id: cornerBottomLeft
        source: placesAssetsPath + "images/layout/corner-bottom-left.png"
        anchors.bottom: parent.bottom
        anchors.left: parent.left
    }
    Image {
        id: cornerBottomRight
        source: placesAssetsPath + "images/layout/corner-bottom-right.png"
        anchors.bottom: parent.bottom
        anchors.right: parent.right
    }
}
