import QtQuick 1.0
import MapsPlugin 1.0

MapViewer {
    mainScreen: parent

    useGlobalShare: true

    signal picked(variant pixelPos, variant geoPos, variant mapObject)

    property variant pickedPixelPos
    property GeoCoordinates pickedGeoPos
    property variant pickedMapObject

    onMapClicked: {
        pickedPixelPos = pixelPos
        pickedGeoPos = geoPos
        pickedMapObject = mapObject
        picked(pixelPos, geoPos, mapObject)
    }
}
