import QtQuick 1.0

import com.nokia.meego 1.0

import ovi.connector 1.0

import ".."

// Route Preview view menu
Menu {
    id: previewMenu
    signal audioSettingsClicked

    property alias audioChecked: audioCommandsMenuItem.checked
    property alias audioEnabled: audioCommandsMenuItem.enabled

    parent: mainscreen

    MenuLayout {
        CheckboxMenuItem {
            id: audioCommandsMenuItem
            objectName: "audioCommandsMenuItem"
            option: qsTranslate("Maps", "qtn_navigationconnector_previewviewmenu_audiocommands")
        }

        MenuItem {
            objectName: "audioSettingsMenuItem"
            text: qsTranslate("Maps", "qtn_navigationconnector_previewviewmenu_audiosettings");
            onClicked: audioSettingsClicked();
        }
    }
}
