import QtQuick 1.0

import ovi.connector 1.0

ConnectorModel {
    id: model
    cloudAdapter: PlacesCloudAdapter {}
    connectorId: "PlacesConnector"

    property string search
    signal contentChanged()

    onUrisChanged: {
        model.updateUris();
    }

    function query(options) {
        log.info("Searching with ConnectorModel");

        //Only search if the box is not empty or has more than empty spaces
        if((options.searchTerm).search(/[0-9]*[a-z]+[0-9]*/i) == -1) {
            return;
        }
        search = options.searchTerm;
        list(options, options.callback);
    }
}
