import QtQuick 1.0

import com.nokia.meego 1.0

Page {
    id: dummy

    property bool placesViewerComponent: true

    property variant model
    property variant object
    property bool openFromFavorite: false

    signal favoriteChanged(bool isFavorite)

    property int recommendationsLeft: 2

    property bool detailsShown: false
    property variant mapsApp
    property variant currentPlace

    function connectedFunction(a) {
        favoriteChanged(a);
    }

    onStatusChanged: {
        mainscreen.reparentInstanceStatus(
            dummy,
            mainscreen["placesInstance" + (recommendationsLeft < 2? recommendationsLeft : "")],
            connectedFunction
        );
    }
}
