import QtQuick 1.0

import com.nokia.meego 1.0

Button {
    property bool withDefaultValue: text == defaultValue || !text

    property string defaultValue
    //property color defaultValueColor: "#B9B9BA"
    property color defaultValueColor: "#000000"
    property color actualValueColor: "#000000"

    onTextChanged: {
        if (text == defaultValue) {
            platformStyle.textColor = defaultValueColor;
        } else if (!text) {
            platformStyle.textColor = defaultValueColor;
            text = defaultValue;
        } else {
            platformStyle.textColor = actualValueColor;
        }
    }
    Component.onCompleted: {
        if (!text) {
            platformStyle.textColor = defaultValueColor;
            text = defaultValue;
        } else {
            platformStyle.textColor = actualValueColor;
        }
    }
}
