import QtQuick 1.0

import com.nokia.meego 1.0

// Map button toggle
Button {
    id: mapToggle;

    property bool mapActive: true

    objectName: "mapToggle";
    height: 50;
    width: visible? 50:0;
    Image {
        anchors.centerIn: parent;
        source: placesAssetsPath + "images/layout/icon-%1_%2.png".arg(
                                        mapActive ? "list" : "map").arg(parent.pressed ? "light": "dark");
    }
    onClicked: {mapActive = !mapActive; }
}
