import QtQuick 1.0

import com.nokia.meego 1.0

Item {
    id: placesCommonDelegate
    width: parent.width

    property bool topMost: ListView.section !== "" && ListView.section !== ListView.previousSection
    // Bug in Qt? ListView.nextSection never set for item 0, big workaround ahead
    property bool bottomMost: ListView.section !== "" && ListView.section !== ListView.nextSection
    property bool showSeparator: false
    property bool partial: true

    height: bottomMost ? 100 - 3 : 100

    PlacesCommonItemSeparator {
        id: separator
        visible: showSeparator
        z: 1
        anchors.top: parent.top
        color: "#f0f1f2"
        height: ListView.section === "" ? 1 : (index === 1 && !parent.topMost ? 4 : (parent.topMost ? 0 : 1))
        partial: parent.partial
    }

}
