import QtQuick 1.0

Item {
    width: parent.width
    height: 7
    property string topColor: "#f0f1f2"
    property string separatorColor: "#c0c1c2"
    property string bottomColor: "#e4e5e6"

    Rectangle {
        anchors.top: parent.top
        width: parent.width
        height: 3
        color: topColor
    }

    Rectangle {
        anchors.verticalCenter: parent.verticalCenter
        width: parent.width
        height: 1
        color: separatorColor
    }

    Rectangle {
        anchors.bottom: parent.bottom
        width: parent.width
        height: 3
        color: bottomColor
    }

    PlacesCommonListSeparatorToken { position: "left" }
    PlacesCommonListSeparatorToken { position: "right" }
}
