import QtQuick 1.0
import MapsPlugin 1.0

Item {
    id: rootApplicationLevel

    x: 0
    y: 0
    width: 854
    height: 480

    MapsMain {
        id: main

        // fake statusbar - will not be shown on Desktop machines
        Rectangle {
            id: statusBar
            height: 0
            width: 0
        }

        Timer {
            id: garbageCollector
            interval: 1
            running: !appState.isDevice
            repeat: true
            onTriggered: appState.gc()
        }
    }
}
