import QtQuick 1.0

Row {
    spacing: 5
    property alias headerText: header.text
    property int fontSize: 14

    Rectangle {
        anchors.verticalCenter: parent.verticalCenter
        width: page.width - header.width -  2*column.anchors.margins
        height: 1
        color: "#e4e5e6"
    }

    Text {
        id: header
        font.pointSize: headerFontSize;
        font.bold: true
        color: "darkgray"
    }
}
