import QtQuick 1.0

Rectangle {
    property alias description: textField.text;

    width: parent.width;
    height: 28;
    radius: 20;

    Text {
        id: textField
        color: "black";
        font.pixelSize: 18;
        font.bold: true;
        anchors.centerIn: parent;
    }

    // color the button with a gradient
    gradient: Gradient {
        GradientStop {
            position: 0.0
            color: "lightgrey"
        }
        GradientStop { position: 1.0; color: "lightblue" }
    }
}

